package com.bonus.canteen.core.supermarket.controller;

import com.bonus.canteen.core.order.domain.OrderInfo;
import com.bonus.canteen.core.order.domain.param.OrderQueryParam;
import com.bonus.canteen.core.order.service.IOrderInfoService;
import com.bonus.canteen.core.supermarket.domain.ShopOrderQueryParam;
import com.bonus.canteen.core.supermarket.domain.SupermarketInfo;
import com.bonus.canteen.core.supermarket.service.SupermarketInfoService;
import com.bonus.common.core.utils.poi.ExcelUtil;
import com.bonus.common.core.web.controller.BaseController;
import com.bonus.common.core.web.domain.AjaxResult;
import com.bonus.common.core.web.page.TableDataInfo;
import com.bonus.common.log.annotation.SysLog;
import com.bonus.common.log.enums.OperaType;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import javax.validation.Valid;
import java.util.List;

/**
 * 超市Controller
 *
 * @author jsk
 * @date 2025-04-05
 */
@Api(tags = "超市接口")
@RestController
@RequestMapping("/supermarket_info")
public class SupermarketInfoController extends BaseController {
    @Autowired
    private SupermarketInfoService supermarketInfoService;
    @Autowired
    private IOrderInfoService orderInfoService;

    /**
     * @author jsk
     * 查询超市列表
     */
    @ApiOperation(value = "查询超市列表")
    @GetMapping("/list")
    public TableDataInfo list(SupermarketInfo SupermarketInfo) {
        startPage();
        List<SupermarketInfo> list = supermarketInfoService.selectSupermarketInfoList(SupermarketInfo);
        return getDataTable(list);
    }

    @ApiOperation(value = "查询超市列表")
    @PostMapping("/getSupermarketList")
    public TableDataInfo getSupermarketList() {
        List<SupermarketInfo> list = supermarketInfoService.getSupermarketList();
        return getDataTable(list);
    }


    /**
     * @author jsk
     * 新增超市
     */
    @ApiOperation(value = "新增超市")
    //@PreventRepeatSubmit
    //@RequiresPermissions("Supermarket:info:add")
    @SysLog(title = "超市", businessType = OperaType.INSERT, logType = 1,module = "商超管理->新增超市")
    @PostMapping("/add")
    public AjaxResult add(@RequestBody SupermarketInfo SupermarketInfo) {
        try {
            return toAjax(supermarketInfoService.insertSupermarketInfo(SupermarketInfo));
        } catch (Exception e) {
            return error("系统错误, " + e.getMessage());
        }
    }

    /**
     * @author jsk
     * 修改超市
     */
    @ApiOperation(value = "修改超市")
    //@PreventRepeatSubmit
    //@RequiresPermissions("Supermarket:info:edit")
    @SysLog(title = "超市", businessType = OperaType.UPDATE, logType = 1,module = "商超管理->修改超市")
    @PostMapping("/edit")
    public AjaxResult edit(@RequestBody SupermarketInfo SupermarketInfo) {
        try {
            return toAjax(supermarketInfoService.updateSupermarketInfo(SupermarketInfo));
        } catch (Exception e) {
            return error("系统错误, " + e.getMessage());
        }
    }

    /**
     * @author jsk
     * 删除超市
     */
    @ApiOperation(value = "删除超市")
    @SysLog(title = "超市", businessType = OperaType.DELETE, logType = 1,module = "商超管理->删除超市")
    @PostMapping("/del")
    public AjaxResult remove(@RequestBody SupermarketInfo supermarketInfo) {
        return toAjax(supermarketInfoService.deleteSupermarketInfoBySupermarketId(supermarketInfo));
    }

    @ApiOperation(value = "查询超市订单列表")
    @PostMapping("/order/list")
    public TableDataInfo orderList(@RequestBody @Valid ShopOrderQueryParam shopOrderQueryParam) {
        startPage();
        shopOrderQueryParam.setStartDateTime(shopOrderQueryParam.getStartDate().atTime(0,0,0));
        shopOrderQueryParam.setEndDateTime(shopOrderQueryParam.getEndDate().atTime(23,59,59));
        OrderQueryParam orderQueryParam = new OrderQueryParam();
        BeanUtils.copyProperties(shopOrderQueryParam, orderQueryParam);
        List<OrderInfo> list = orderInfoService.selectOrderInfoList(orderQueryParam);
        return getDataTable(list);
    }

}
